// Graphical interface for dynamicMC program
//This program is part of dynamicMC project developed by Mehrdad S. Beni
//Do NOT distribute without permission
//copyright held by Mehrdad S. Beni
//libraries needed by the program
#include <SFML/Graphics.hpp>
#include <iostream>
#include <math.h>
#include <stdio.h>
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>
#include <bits/stdc++.h>
//setting standard namespace
using namespace std;

// Sprite speed (high values = high speed)
#define         SPRITE_SPEED        3

int main()
{
    // _____
    // ::: Create window :::
	//window size, do NOT change unless you know what you are doing
    int vidmod = 900;

    // Create a window with the same pixel depth as the desktop
   // sf::VideoMode desktopMode = sf::VideoMode::getDesktopMode();
   sf::RenderWindow window(sf::VideoMode(vidmod, vidmod), "dynamicMC");

    //sf::RenderWindow window(sf::VideoMode(  desktopMode.width,
     //                                       desktopMode.height,
     //                                       desktopMode.bitsPerPixel),
      //                      "SFML part 3",
      //                      sf::Style::Fullscreen);

    // Enable vertical sync. (vsync)
    window.setVerticalSyncEnabled (true);
    // When a key is pressed, sf::Event::KeyPressed will be true only once
    window.setKeyRepeatEnabled(false);

    // ____
    // ::: Load texture :::

    // Create texture from PNG file
    sf::Texture texture;
    if (!texture.loadFromFile("./pic2.png"))
    {
        std::cerr << "Error while loading phantom texture" << std::endl;
        return -1;
    }
    // source resource file, setting a sprite
    sf::Texture texture2;
    if (!texture2.loadFromFile("./source.png"))
    {
        std::cerr << "Error while loading source texture" << std::endl;
        return -1;
    }

	//showing previous phantom location as a black dot
    sf::Texture texture3;
    if (!texture3.loadFromFile("./pos.png"))
    {
        std::cerr << "Error while loading source texture" << std::endl;
        return -1;
    }


    // Enable the smooth filter. The texture appears smoother so that pixels are less noticeable.
   // texture.setSmooth(true);

    // ___________
    // ::: Create sprite and apply texture :::

    // Create the sprite and apply the texture
    sf::Sprite sprite;
    sprite.setTexture(texture);
    sf::FloatRect spriteSize=sprite.getGlobalBounds();
    sprite.setOrigin(spriteSize.width/2.,spriteSize.height/2.);
    
    //source sprite here
    sf::Sprite sprite2;
    sprite2.setTexture(texture2);
    sf::FloatRect spriteSize2=sprite2.getGlobalBounds();
    sprite2.setOrigin(spriteSize2.width/2.,spriteSize2.height/2.);

    //position locaction set by the user at last
    sf::Sprite sprite3;
    sprite3.setTexture(texture3);
    sf::FloatRect spriteSize3=sprite3.getGlobalBounds();
    sprite3.setOrigin(spriteSize3.width/2.,spriteSize3.height/2.);

//        string out="hello";
//    int sc = 5;
//    sprintf(out,"test: %i", sc);
//    sf::Text text(out);
    
    //std::stringstream ss;

    sf::Font font;
    if (!font.loadFromFile("./OpenSans-Regular.ttf"))
    {
        std::cerr << "error font" << std::endl;
        return -1;
    }
    sf::Text text;
    sf::Text text2;
    
    //variables used to change integer to char
	//do NOT change
    //int g=10;
    char numstr1[10];
    char numstr2[10];

    text.setFont(font);
    text.setCharacterSize(30);
    text.setColor(sf::Color::Black);
    text.setOrigin(spriteSize.width/2.,spriteSize.height/2.);
   // std::cout << text.getLocalBounds().width << "\t" << text.getLocalBounds().height;
    text2.setFont(font);
    text2.setCharacterSize(30);
    text2.setColor(sf::Color::Black);
    text2.setOrigin(spriteSize.width/2.,spriteSize.height/2.);

        // _____
    // ::: Main loop :::

    // Sprite coordinates
    int x=window.getSize().x/2. + 10;
    int y=window.getSize().y/2.;



    // Flags for key pressed
    bool upFlag=false;
    bool downFlag=false;
    bool leftFlag=false;
    bool rightFlag=false;
    bool spaceFlag=false;

		int r;
	ifstream myfile3 ("r.tmp");
	if (myfile3.is_open())
	{
	  myfile3 >> r;
	}

    ofstream myfile ("x.tmp");
    ofstream myfiley ("y.tmp");
    
    if (myfile.is_open())
      {

    if (myfiley.is_open())
      {
          int cnt = 0;
        
    sf::Clock timer;
    while (window.isOpen())
    {
        window.setFramerateLimit(80); // Limit to 60 frames per second
        
 
        
        
        // Process events
        sf::Event event;
        while (window.pollEvent(event))
        {
            // Close the window if a key is pressed or if requested
            if (event.type == sf::Event::Closed) window.close();

            // If a key is pressed
            if (event.type == sf::Event::KeyPressed)
            {
                switch (event.key.code)
                {
                // If escape is pressed, close the application
                case  sf::Keyboard::Escape : window.close(); break;

                // Process the up, down, left and right keys
                    case sf::Keyboard::Space:   spaceFlag=true; break;
                case sf::Keyboard::Up :     upFlag=true; break;
                case sf::Keyboard::Down:    downFlag=true; break;
                case sf::Keyboard::Left:    leftFlag=true; break;
                case sf::Keyboard::Right:   rightFlag=true; break;
                        
                        
        
                default : break;
                }
                
                if (spaceFlag)  {
                    
                    sf::Vector2f position = sprite.getPosition();
                    


                  sprite3.setPosition(position.x,position.y);

	            int posx = position.x - vidmod/2;
                    int posy;
                    if(position.y <= vidmod/2){
                    posy = vidmod/2 - position.y;
                    }
                    if(position.y > vidmod/2){
                    posy = vidmod/2 - position.y;



    

                    }

			    ofstream myfile2 ("n.tmp");
			
			if(abs(posx) < r+21){

				//cout << "x position out of bound" << endl;
			//char[10] jj; 
			string str="x out of bound";
			//numstr1 ==  "out";
			
			strcpy(numstr1, str.c_str());
			} 
 			if(abs(posy) < r+21){

				//cout << "y position out of bound" << endl;
			string stq="y out of bound";
			//numstr1 ==  "out";
			
			strcpy(numstr2, stq.c_str());
			//numstr2 == "j";
			}               
                        
                    if(abs(posx) > r+21 || abs(posy) > r+21){
			cnt++;
                    sprintf(numstr1, "%i", posx);
                    sprintf(numstr2, "%i", posy);
//	           myfile << cnt << " " << posx << " " << posy << endl;
		   
		myfile << posx << endl;			
		myfiley << posy << endl;		

			
		//cout << position.x << " " << position.y << endl;

			
    			if (myfile2.is_open())
      				{
				  myfile2 << cnt << endl;		
				}

	

			}
//                    sprite2.setPosition(position.x,position.y);
  //                  window.draw(sprite2);
                }
            }

            // If a key is released
            if (event.type == sf::Event::KeyReleased)
            {
                switch (event.key.code)
                {
                // Process the up, down, left and right keys
                    case sf::Keyboard::Space:   spaceFlag=false; break;
                case sf::Keyboard::Up :     upFlag=false; break;
                case sf::Keyboard::Down:    downFlag=false; break;
                case sf::Keyboard::Left:    leftFlag=false; break;
                case sf::Keyboard::Right:   rightFlag=false; break;
  
                default : break;
                }
            }
        }

    

        // Update coordinates
        if (leftFlag) x-=SPRITE_SPEED;
        if (rightFlag) x+=SPRITE_SPEED;
        if (upFlag) y-=SPRITE_SPEED;
        if (downFlag) y+=SPRITE_SPEED;



    

        // Check screen boundaries
        if (x<0) x=0;
        if (x>(int)window.getSize().x) x=window.getSize().x;
        if (y<0) y=0;
        if (y>(int)window.getSize().y) y=window.getSize().y;

        // Clear the window and apply grey background
        window.clear( sf::Color(127,127,127));


        // Rotate and draw the sprite
        sprite.setPosition(x,y);
        
        sprite2.setPosition(vidmod/2 - 10,vidmod/2);

 

        //issue with writing into file as screen refreshes here*******


    

    

      //  sprite.setRotation( timer.getElapsedTime().asSeconds() / M_PI * 90.f );
        window.draw(sprite);
        
        window.draw(sprite2);
	//sf::Vector2f position = sprite.getPosition();

        		

                  window.draw(sprite3);
       // stringstream  h; // << g;
       // h << g;

        text.setString(numstr1);
        text2.setString(numstr2);


   // text.setPosition(window.getSize().x/2.,window.getSize().y/2.);
        text.setPosition(vidmod/4,vidmod/30);
        text2.setPosition(vidmod/4 + vidmod/2,vidmod/30);
        window.draw(text);
        window.draw(text2);
// Update display and wait for vsync
        window.display();

		//space key set location and write into output file used by the main program
	}    
	myfiley.close();
    }
    myfile.close();
	//myfile2.close();
     
	// Graphical interface for dynamicMC program
//This program is part of dynamicMC project developed by Mehrdad S. Beni
//Do NOT distribute without permission
//copyright held by Mehrdad S. Beni
   
    }
       
    return 0;

 }
